package com.paint.trace.drawing.item;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.FrameLayout;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.paint.trace.drawing.topon.AdManager;
import com.paint.trace.drawing.topon.onActionListener;
import com.paint.trace.drawing.view.MyApplication;
import com.paint.trace.drawing.R;
import com.paint.trace.drawing.other.AssetData;
import com.paint.trace.drawing.view.PreViewActivity;
import com.paint.trace.drawing.db.ObjectBox;
import com.paint.trace.drawing.other.Utils;

import java.util.List;

public class LikeAdapter extends RecyclerView.Adapter<LikeAdapter.HomeVH> {


    private Activity mCon;
    private List<AssetData> data;


    public void setData(List<AssetData> data) {
        this.data = data;
        notifyDataSetChanged();
    }
    public LikeAdapter(Activity mCon) {
        this.mCon = mCon;
    }

    @NonNull
    @Override
    public HomeVH onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.adapter_thumb, parent, false);
        return new HomeVH(view);
    }

    @Override
    public void onBindViewHolder(@NonNull HomeVH holder, int position) {
        AssetData assetData = data.get(position);
        String name = assetData.getPath();
        Log.d("---------tt", "---------favorite=" + name);
        new Thread(new Runnable() {
            @Override
            public void run() {
                Bitmap bitmap = Utils.loadImage(mCon, name);
                mCon.runOnUiThread(()->{
                    holder.previewIm.setImageBitmap(bitmap);
                });

            }
        }).start();


        holder.imFavorite.setSelected(true);
        holder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                AdManager.showTopOn(mCon, new onActionListener() {
                    @Override
                    public void onAction() {
                        Intent intent = new Intent(mCon, PreViewActivity.class);
                        intent.putExtra(MyApplication.Key_Camera, name);
                        mCon.startActivity(intent);
                    }
                });
            }
        });

        holder.cardFavorite.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                holder.imFavorite.setSelected(false);
                ObjectBox.deleteLike(name);
                int adapterPosition = holder.getAdapterPosition();
                notifyItemRemoved(adapterPosition);

            }
        });
    }

    @Override
    public int getItemCount() {
        return data.size();
    }

    public static class HomeVH extends RecyclerView.ViewHolder {
        private ImageView previewIm, imFavorite;

        private CardView cardView ;
        private FrameLayout cardFavorite;

        public HomeVH(@NonNull View itemView) {
            super(itemView);
            previewIm = itemView.findViewById(R.id.imPreview);
            cardView = itemView.findViewById(R.id.card_view);
            cardFavorite = itemView.findViewById(R.id.card_favorite);
            imFavorite = itemView.findViewById(R.id.im_favorite);
        }


    }
}
